/* Simple example code for Force Sensitive Resistor (FSR) with Arduino. More info: https://www.makerguides.com */

#include <IRremote.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

#include <SPI.h>                //RFID
#include <MFRC522.h>           //RFID

// Parameters for Door Open / Close Management
const int switchPinDoorC = 9;        //Switch Connected to PIN 9 -- DOOR CLOSED
const int ledPinBlue = 4;             //LED Connected to PIN 4 -- BLUE LED WHEN DOOR OPENED
int switchStateDoorC = 0;             // Variable for reading Switch status for Door CLosed

const int switchPinDoorO = 10;        //Switch Connected to PIN 10 -- DOOR OPENED
const int ledPinGreen = 5;             //LED Connected to PIN 5 -- GREEN LED WHEN DOOR IS WIDE OPENED
int switchStateDoorO = 1;             // Variable for reading Switch status for Door CLosed

int DoorStatus = 0;



// Define variable for Ultra Sonic Sensor
#define echoPin 2 // attach pin D2 Arduino to pin Echo of HC-SR04
#define trigPin 3 //attach pin D3 Arduino to pin Trig of HC-SR04

// Define FSR pin:
#define fsrpin A0

// defines variable to store Ultra Sonic sensor measurements
long duration; // variable for the duration of sound wave travel
int distance; // variable for the distance measurement
int initdist =0; 
int iteration =1; 
int USstate=0;

//Define variable to store Weight sensor readings:
int fsrreading; //Variable to store FSR value
int iter;
int iter2=0;

int t=0;

//Bouton arrêt alarme après constation
const int btnPin  = A8;
const int ledPin = 14;
const int Alarm;
//Variables pour bouton Arrêt Alarme
int btnVal  = 0;
bool btnState  = false;
bool oldbtnState  = false;
bool ledState  = LOW;


// Variable Declaration For Touchless switch - sensor -- HALL Sensor
int currentState = LOW;     // the current reading from the input pin
// constants won't change. They're used here to set pin numbers:
const int SENSOR_PIN = 7;       // the Arduino's input pin that connects to the sensor's SIGNAL pin 
// Variables will change:
int lastState = LOW;  // the previous state from the input pin
int newState = LOW;


void setup() {
  // Begin serial communication at a baud rate of 9600:
  Serial.begin(9600);
  Wire.begin(); 

  // initialize the Arduino's pin as Input / Ouput for Door Bridge management system
  pinMode(ledPinBlue, OUTPUT);           //BLUE LED PIN is Output
  pinMode(switchPinDoorC, INPUT_PULLUP);        //Switch DOOR FULLY CLOSED PIN is input 

  pinMode(ledPinGreen, OUTPUT);           //GREEN LED PIN is Output
  pinMode(switchPinDoorO, INPUT_PULLUP);        //Switch DOOR WIDE OPENED PIN is input 


         
  // initialize the Arduino's pin as an input for HALL Sensor
  pinMode(SENSOR_PIN, INPUT);
  
  // initialise the Buzzer's pin
  pinMode(12, OUTPUT);

  // initialize Function KNOB for Alarm Stop
  Serial.println(F("Initialize System"));
  //Init btn
  pinMode(btnPin, INPUT_PULLUP);
  pinMode(ledPin, OUTPUT);

  // initialize Ultra Sonic motion sensor
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an OUTPUT
  pinMode(echoPin, INPUT); // Sets the echoPin as an INPUT
  
}


  

void loop() {

  // Bridge between the 2 systems  utilizing the 2 Door Switches
  // *********************************************

    switchStateDoorC = digitalRead(switchPinDoorC);   //Reads the status of the DOOR CLOSED
    switchStateDoorO = digitalRead(switchPinDoorO);   //Reads the status of the DOOR WIDE OPENED
    
   if (switchStateDoorC == LOW and switchStateDoorO == HIGH)             //If the switch is pressed
    {
        digitalWrite(ledPinBlue, LOW);         //BLUE LED OFF
        digitalWrite(ledPinGreen, LOW);        //GREEN LED OFF
        delay(1000);  
        DoorStatus = 1;
        Serial.print("DOOR STATUS");Serial.println(DoorStatus);
        //switchStateDoorC = digitalRead(switchPinDoorC);   //Reads the status of the DOOR CLOSED
        //switchStateDoorO = digitalRead(switchPinDoorO);   //Reads the status of the DOOR WIDE OPENED
    }

  if (switchStateDoorC == HIGH and switchStateDoorO == HIGH)             //If the switch is depressed
    {
        digitalWrite(ledPinBlue, HIGH);         //BLUE LED ON
        digitalWrite(ledPinGreen, LOW);        //GREEN LED OFF
        DoorStatus = 2;
        Serial.print("DOOR STATUS");Serial.println(DoorStatus);
        //Serial.println("DOOR IS TRAVELLING");
        delay(1000);
        switchStateDoorC = digitalRead(switchPinDoorC);   //Reads the status of the DOOR CLOSED
        switchStateDoorO = digitalRead(switchPinDoorO);   //Reads the status of the DOOR WIDE OPENED
        
    }
    
    if (switchStateDoorC == HIGH and switchStateDoorO == LOW)     
    {
        digitalWrite(ledPinBlue, LOW);         //BLUE LED OFF
        digitalWrite(ledPinGreen, HIGH);        //GREEN LED ON
        //Serial.println("DOOR IS WIDE OPENED");
        DoorStatus = 3;
        Serial.print("DOOR STATUS");Serial.println(DoorStatus);
        delay(1000);
        switchStateDoorC = digitalRead(switchPinDoorC);   //Reads the status of the DOOR CLOSED
        switchStateDoorO = digitalRead(switchPinDoorO);   //Reads the status of the DOOR WIDE OPENED
        
     }
        
    //switchStateDoorC = digitalRead(switchPinDoorC);   //Reads the status of the DOOR CLOSED
    //switchStateDoorO = digitalRead(switchPinDoorO);   //Reads the status of the DOOR WIDE OPENED
    

  
  //********************************************* End of Loop for Door Switches Status
  //*********************************************


  
  // HALL SENSOR Switch - for ALARM Activation:
    currentState = digitalRead(SENSOR_PIN);

  if (((lastState == LOW && currentState == HIGH && newState == HIGH)or (lastState == HIGH && currentState == LOW && newState == LOW) or (lastState == LOW && currentState == LOW && newState == LOW)or (lastState == HIGH && currentState == HIGH && newState == HIGH))and(DoorStatus == 1)) 
    
    {  
    if (newState == HIGH)
    {
      tone(12, 400, 300);
      tone(12, 400, 600);
    }
    
    newState = LOW;  
    Serial.println("The Hall Sensor Status - ALARM IS DEACTIVATED");
    Serial.print("OLD - CURRENT - NEW : ");
    Serial.print(lastState);Serial.print(" - ");Serial.print(currentState);Serial.print(" - ");Serial.println(newState);
    delay(2000);
    
    currentState = digitalRead(SENSOR_PIN);
    fsrreading = 249; // Send the FSR pin and store the output as fsrreading - to indicate ALARM OFF
    //serial.print("deactivation code");serialprintln(fsrreading);
    Wire.beginTransmission(20);
    Wire.write(249);
    Wire.endTransmission(); // Send Value by I2C Protocol to Slave Arduino for displaying Correct Screen : code 249
    delay (2000);
      
    }
 
    else if (((lastState == LOW && currentState == HIGH && newState == LOW)or (lastState == HIGH && currentState == LOW && newState == HIGH) or(lastState == LOW && currentState == LOW && newState == HIGH)or(lastState == HIGH && currentState == HIGH && newState == LOW)) and (DoorStatus == 1))
    {
      
    if (newState == LOW)
    {
      tone(12, 400, 600);
      tone(12, 400, 300);
    }
    
    newState = HIGH;
    Serial.println("The sensor is released - ALARM IS ON");
    lastState = HIGH; 
    Serial.print("OLD - CURRENT - NEW : ");
    Serial.print(lastState);Serial.print(" - ");Serial.print(currentState);Serial.print(" - ");Serial.println(newState);
    delay(2000);
    
    USsensor0();// Ultra Sonic SENSOR - Set up of US Sensor reference to caculate afterwards field variation
    fsrreading = analogRead(fsrpin);// Read the FSR pin and store the output as fsrreading - for WEIGHT SENSOR:
    Serial.println("Master Analog reading Weight Sensor = ");Serial.println(fsrreading);
    
    USsensor1();// Ultra Sonic SENSOR - Calculate variation in the field 
    if (iter2>=2)
      {
      fsrreading =607; // if Weight Sensor senses for 2 iterations in a row a significant weight - Intrusion Flag is sent
      }
    
    Serial.println("US Sensor Reading US State");Serial.println(USstate); // Return USstate = variation measured in the field
    //Serial.println("*****************************************************************");
  
    if (fsrreading < 150) // WEIGHT SENSOR -- THRESHOLD FOR NO MOVEMENT BEING SENSES - Max 150
      {
      Serial.println(" No Movement seen by Weight sensor");
      Wire.beginTransmission(20);
      Wire.write(0);
      Wire.endTransmission(); // Send Value by I2C Protocol to Slave Arduino for displaying Correct Screen : 0
      delay (2000);
      } 
      
      else if (fsrreading < 300 and fsrreading >= 150) // WEIGHT SENSOR -- THRESHOLD FOR PET MOVEMENT - From 150 up to Max 300
      {
      Serial.println(" Detection of lightweight body - most likely a pet");
      Wire.beginTransmission(20);
      Wire.write(157);
      Wire.endTransmission(); // Send Value by I2C Protocol to Slave Arduino for displaying Correct Screen : 157
      delay (2000);
      }
      
      else if ((fsrreading < 600 and fsrreading >=300) and USstate ==1)// WEIGHT SENSOR -- THRESHOLD FOR ABNORMAL MOVEMENT - From 300 up to Max 600
      {
      Serial.println("Abnormal Movement Detected");
      Wire.beginTransmission(20);
      Wire.write(307);
      Wire.endTransmission(); // Send Value by I2C Protocol to Slave Arduino for displaying Correct Screen : 307
      iter2=iter2+1;          // Count the iteration for Significant Weight variation - Prevention of Ghost Signals and Alarm Reaction
      Serial.println(F("ITER 2 : "));
      Serial.println(iter2);
      delay (2000);
      } 
      
      else if ((fsrreading >= 600) or (iter2>=2))// WEIGHT SENSOR -- THRESHOLD FOR ABNORMAL MOVEMENT - INTRUSION - Above 600
      {
      Serial.println(" Possible Intrusion - Individuals Likely !!!!");
      Wire.beginTransmission(20);
      Wire.write(607);
      Serial.println(F("sending value : "));
      Serial.println(607);
      Wire.endTransmission(); // Send Value by I2C Protocol to Slave Arduino for displaying Correct Screen : 607
      delay (2000);
    
      // Alarm BEEP and Securty Agent Control Button
      ledState = HIGH;
      digitalWrite(ledPin, ledState);
      btnVal = analogRead(btnPin);
      Serial.println("BEEP");
      Alarm==1;
      oldbtnState = false;
      btnVal = 100;
      sono(); // BEEP Procedure

      while (btnVal <200)
        {
        //tone (12, 600); // allume le buzzer actif arduino
        //delay(500);
        tone(12, 900); // allume le buzzer actif arduino
        delay(500);
        noTone(12);  // désactiver le buzzer actif arduino
        delay(500);

        //sono();
        btnVal = analogRead(btnPin);
        if (btnVal >200)
          {
          btnState = false;
          btnVal = 100;
          }
        else 
          {
          btnState = true;
          Serial.print("valeir btnVal");Serial.print(btnVal);
          Serial.print(F("Button was pressed")); Serial.print(F("-->")); Serial.print(F("LED "));
          ledState = !ledState;
          Serial.println(ledState);
          digitalWrite(ledPin, ledState);
          btnVal = 300;
          }
        }
      iter2=0; 
      initdist= distance;   
      }
   
    delay (1000);
    //currentState = digitalRead(SENSOR_PIN);
    //if (currentState == HIGH)
      //{
      //newState = HIGH;
      //exit(0);
      //return;
      //}
      //else if (currentState == LOW)
      //{
      //newState = LOW;
      //}
      //Serial.print(lastState);Serial.print(" - ");Serial.print(currentState);Serial.print(" - ");Serial.println(newState);
      }
   }



// End of MAIN BODY PROGRAM 
//*********************************************************
//*********************************************************


void USsensor0() {
  // Clears the trigPin condition
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  // Displays the distance on the Serial Monitor
  
 if (iteration ==1)
  {
  Serial.println("US SENSOR - Initial Distance: ");
  initdist = distance;
  Serial.println(initdist);
  Serial.println(" cm");
  //iteration = iteration +1;
  //Serial.println("iteration: ");
  //Serial.print(iteration);
  iteration= iteration +1;
  delay(1000);
  }
  
}

void USsensor1(){
  // Clears the trigPin condition
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin HIGH (ACTIVE) for 10 microseconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  
  distance = duration * 0.034 / 2; // Speed of sound wave divided by 2 (go and back)
  // Displays the distance on the Serial Monitor
   
  if (distance == initdist)
  {
    Serial.println("NO MOVEMENT Detected by US sensor");
    USstate=0;
    //delay(1000);
    iteration == iteration +1;
    
  }

  if (distance != initdist)
  {
  Serial.println("US Sensor detected Displacement: ");
  Serial.println(distance-initdist);
  Serial.println(" cm");
  USstate=1;
  // Movement has been detected
  delay(1000);
  //iteration == iteration +1;
  }
 
}



void sono() {
// Gestion Buzzer Intrusion   
for (t; t<2; t++)
   {
   // instructions à exécuter
   tone (12, 600); // allume le buzzer actif arduino
   delay(500);
   tone(12, 900); // allume le buzzer actif arduino
   delay(500);
   noTone(12);  // désactiver le buzzer actif arduino
   delay(500);
   }
   t=0;
}
